package common;

import com.CWebApplication;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hai.common.utils.HttpsUtils;
import com.hai.entity.SecRegion;
import com.hai.service.CommonService;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.web.WebAppConfiguration;

import javax.annotation.Resource;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.*;

/**
 * @ClassName RegionTest
 * @Description: TODO ()
 * @Author 胡锐
 * @Date 2020/12/29
 **/
@RunWith(SpringJUnit4ClassRunner.class)
@SpringBootTest(classes = CWebApplication.class)
@WebAppConfiguration
public class RegionTest {

    @Resource
    private CommonService commonService;

    private static final String[] HEX_DIGITS = {"0" ,"1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"};

    @Test
    public void addLogs(){
        try {
            OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream("exampleWrite.json"),"UTF-8");
            List<Map<String,Object>> jobTypeList = new ArrayList<>();
            List<Map<String,Object>> children1;

            List<SecRegion> parentRegion = commonService.getCities();
            for (SecRegion parent : parentRegion) {
                Map<String,Object> map = new HashMap<>();
                map.put("value", parent.getRegionId());
                map.put("label", parent.getRegionName());

                // 查询二级
                List<SecRegion> chinRegion = commonService.getRegionsByParentId(parent.getRegionId());
                children1 = new ArrayList<>();
                for (SecRegion chin : chinRegion) {
                    Map<String,Object> map1 = new HashMap<>();
                    map1.put("value", chin.getRegionId());
                    map1.put("label", chin.getRegionName());
                    children1.add(map1);
                }

                map.put("children", children1);
                jobTypeList.add(map);
            }

            osw.write(JSON.toJSONString(jobTypeList));
            osw.flush();//清空缓冲区，强制输出数据
            osw.close();//关闭输出流
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    @Test
    public void test(){
        try {

            Map<String,Object> map = new HashMap<>();
            map.put("appId", "js3w7K4W0SglB6bNPVjs3w7K4W0SglB6bNPV");
            map.put("appSecret", "SoIXquKSKT8s7sa6ySjfyBXxKTC4Jhqx7fiE1qT0XWrrnkScurMGsLdGrz5ThLo5");
            Long date  = new Date().getTime();
            String signature = "mUGcV7CxPYRuzIWXd72bVknKYCXuT7d1tRxQUdVR9iAcxxTdmWC8lTo0rL5wDZwLmTwQnpCqeHz3MtAIVBrm99WmtPv93pRdgWcIkkgPt18pAFyavYrPt80Yh8iyFr8s";
            String sha256 = encodeBySHA256(signature + JSON.toJSONString(map) + date);


            Map<String,Object> map2 = new HashMap<>();
            map2.put("signature", signature);
            map2.put("body", JSON.toJSONString(map));
            map2.put("ts", date);
            JSONObject jsonObject = HttpsUtils.doPost("https://app.zshcqsy.com/api-provider/api/open/merchant/token", JSON.toJSONString(map2));
            System.out.println(jsonObject.toJSONString());

        }catch (Exception e){
            e.printStackTrace();
        }
    }

    public String encodeBySHA256(String str) {
        try{
            MessageDigest messageDigest = MessageDigest.getInstance("SHA-256");
            messageDigest.reset();
            messageDigest.update(str.getBytes("UTF-8"));
            return getFormattedText(messageDigest.digest());
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (Exception e) {
          throw new RuntimeException(e);
        }
        return "";
    }

    private String getFormattedText(byte[] bytes) {
        int len = bytes.length;
        StringBuilder buf = new StringBuilder(len * 2);
        // 把密文转换成十六进制的字符串形式
        for (int j=0;j<len;j++){
            buf.append(HEX_DIGITS[(bytes[j] >> 4) & 0x0f]);
            buf.append(HEX_DIGITS[bytes[j] & 0x0f]);
        }
        return buf.toString();
    }

}
